(defun
     *MERRMSG* (MSG)
  (princ MSG)
  (setvar "cecolor" "BYLAYER")
  (setvar "blipmode" 1)
  (setvar "cmdecho" 0)
  (setvar "menuecho" 2)
  (setq *ERROR* M:ERR
        M:ERR NIL
  ) ;_ end of setq
  (princ)
) ;_ end of defun

(defun ;Saklfelx
     PROPS (/ COLOR LTYPE)
  (setvar "clayer" (FLDVAL 8 EL))
  (setvar
    "cecolor"
    (if (setq COLOR (FLDVAL 62 EL))
      (itoa COLOR)
      "bylayer"
    ) ;_ end of if
  ) ;_ end of setvar
  (setvar
    "celtype"
    (if (setq LTYPE (FLDVAL 6 EL))
      LTYPE
      "bylayer"
    ) ;_ end of if
  ) ;_ end of setvar
) ;_ end of defun

(defun ;Ytsvfevrbsmkpy
     XARC (/ CMD)
  (PROPS)
  (setq CMD "arc")
  (prompt (strcat "\nCommand: " CMD " "))
  (command CMD)
) ;_ end of defun

(defun
     XCIRCLE (/ CMD)
  (PROPS)
  (setq CMD "circle")
  (prompt (strcat "\nCommand: " CMD " "))
  (command CMD)
) ;_ end of defun

(defun
     XINSERT (/ CMD NAME XSIZE YSIZE ANG)
  (PROPS)
  (setq CMD   "insert"
        NAME  (FLDVAL 2 EL)
        XSIZE (FLDVAL 41 EL)
        YSIZE (FLDVAL 42 EL)
        ANG   (FLDVAL 50 EL)
  ) ;_ end of setq
  (prompt (strcat "\nCommand: " CMD " " NAME))
  (command
    CMD
    NAME
    "X"
    XSIZE
    "Y"
    YSIZE
    "R"
    (angtos ANG)
  ) ;_ end of command
) ;_ end of defun

(defun
     XLINE (/ CMD)
  (PROPS)
  (setq CMD "line")
  (prompt (strcat "\nCommand: " CMD " "))
  (command CMD)
) ;_ end of defun

(defun
     XPOINT (/ CMD)
  (PROPS)
  (setq CMD "point")
  (prompt (strcat "\nCommand: " CMD " "))
  (command CMD)
) ;_ end of defun

(defun
     XPLINE (/ CMD)
  (PROPS)
  (setq CMD "pline")
  (setvar "plinewid" (FLDVAL 40 EL))
  (prompt (strcat "\nCommand: " CMD " "))
  (command CMD)
) ;_ end of defun

(defun
     XSHAPE (/ CMD NAME SCALE)
  (PROPS)
  (setq CMD   "shape"
        NAME  (FLDVAL 2 EL)
        SCALE (FLDVAL 40 EL)
  ) ;_ end of setq
  (prompt
    (strcat
      "\nCommand: "
      CMD
      " "
      NAME
      " Starting point: "
    ) ;_ end of strcat
  ) ;_ end of prompt
  (command CMD NAME PAUSE SCALE)
) ;_ end of defun

(defun
     XSOLID (/ CMD)
  (PROPS)
  (setq CMD "solid")
  (prompt (strcat "\nCommand: " CMD " "))
  (command CMD)
) ;_ end of defun

(defun
     XTEXT (/ CMD NAME CODE72 CODE73 JUSTIFY)
  (PROPS)
  (setq CMD    "dtext"
        NAME   (FLDVAL 7 EL)
        CODE72 (FLDVAL 72 EL)
        CODE73 (FLDVAL 73 EL)
  ) ;_ end of setq
  (setq JUSTIFY
         (cond ((= 0 CODE72) "L")
               ((= 1 CODE72) "C")
               ((= 2 CODE72) "R")
               ((= 3 CODE72) "A")
               ((= 4 CODE72) "M")
               ((= 5 CODE72) "F")
         ) ;_ end of cond
  ) ;_ end of setq
  (setq JUSTIFY
         (strcat
           (cond ((= 1 CODE73) "B")
                 ((= 2 CODE73) "M")
                 ((= 3 CODE73) "T")
                 (t "")
           ) ;_ end of cond
           JUSTIFY
         ) ;_ end of strcat
  ) ;_ end of setq
  (prompt
    (strcat "\nCommand: " CMD " Style " NAME " ")
  ) ;_ end of prompt
  (if (and (zerop CODE72) (zerop CODE73))
    (command CMD "S" NAME)
    (command CMD "S" NAME JUSTIFY)
  ) ;_ end of if
) ;_ end of defun

(defun
     XTRACE (/ CMD WID)
  (PROPS)
  (setq CMD "trace"
        WID (distance (FLDVAL 10 EL) (FLDVAL 11 EL))
  ) ;_ end of setq
  (prompt (strcat "\nCommand: " CMD ""))
  (command CMD WID)
) ;_ end of defun

(defun
     XVPORT (/ CMD PT)
  (PROPS)
  (initget 1)
  (setq CMD ".mview"
        PT  (getpoint
              (strcat "\nCommand: " CMD " First point: ")
            ) ;_ end of getpoint
  ) ;_ end of setq
  (command CMD PT)
) ;_ end of defun


;;; ------------- [FLDVAL]
;;; This sub-routine is called by other
;;; functions/commands and requires an integer
;;; argument,(code), and an entity
;;; list
;;; argument, (elst).  The function will return the
;;; value associated with "CODE" in
;;; "ELST".

(defun FLDVAL (CODE ELST) (cdr (assoc CODE ELST)))



;;; The command, "Drwqik", will begin the AutoCAD
;;; command to draw a similar entity that the user
;;; is
;;; prompted to
;;; select.
;;; Before the command begins, the layer, color, &
;;; linetype properties will be set current, and if
;;; applicable,
;;; other options (e.g. style, scale, width, etc.)
;;; will
;;; be preset before the AutoCAD command is
;;; executed.


(defun
     Drwqik (/ ENT EL)
  (setq M:ERR   *ERROR*
        *ERROR* *MERRMSG*
  ) ;_ end of setq
  (if (setq ENT (car (entsel "\nSelect object: ")))
    (progn
      (setq EL (entget ENT))
      (cond ((= "ARC" (FLDVAL 0 EL)) (XARC))
            ((= "CIRCLE" (FLDVAL 0 EL)) (XCIRCLE))
            ((= "INSERT" (FLDVAL 0 EL)) (XINSERT))
            ((= "LINE" (FLDVAL 0 EL)) (XLINE))
            ((= "POINT" (FLDVAL 0 EL)) (XPOINT))
            ((= "POLYLINE" (FLDVAL 0 EL)) (XPLINE))
            ((= "SHAPE" (FLDVAL 0 EL)) (XSHAPE))
            ((= "SOLID" (FLDVAL 0 EL)) (XSOLID))
            ((= "TEXT" (FLDVAL 0 EL)) (XTEXT))
            ((= "TRACE" (FLDVAL 0 EL)) (XTRACE))
            ((= "VIEWPORT" (FLDVAL 0 EL)) (XVPORT))
            (t
             (alert
               (strcat
                 (FLDVAL 0 EL)
                 " cannot be used with Drwqik"
               ) ;_ end of strcat
             ) ;_ end of alert
            )
      ) ;_ end of cond
    ) ;_ end of progn
    (prompt "\nNothing selected.")
  ) ;_ end of if
  (setq *ERROR* M:ERR
        M:ERR NIL
  ) ;_ end of setq
  (princ)
) ;_ end of defun

(defun C:Drwqik () (Drwqik))
(defun C:D () (Drwqik))

;QUICKDRAW